with Ada.Command_Line; use Ada.Command_Line;
with Ada.Containers.Indefinite_Ordered_Sets;
with Ada.Containers.Doubly_Linked_Lists;
with Ada.Directories; use Ada.Directories;
with Ada.Text_IO; use Ada.Text_IO;
with Ada.Strings.Equal_Case_Insensitive; use Ada.Strings;
with Ase.Processes; use Ase.Processes;
with Ase.Processes.text_io; use Ase.Processes.text_io;
procedure list_ali is
	package String_Sets is new Ada.Containers.Indefinite_Ordered_Sets(String);
	use String_Sets;
	function Default_Symbols return String_Sets.Set is
	begin
		return Result : String_Sets.Set do
			Include(Result, "Ada");
			Include(Result, "Address_To_Access_Conversions");
			Include(Result, "Arithmetic");
			Include(Result, "Assertions");
			Include(Result, "Asynchronous_Task_Control");
			Include(Result, "Bounded");
			Include(Result, "Bounded_IO");
			Include(Result, "C");
			Include(Result, "Calendar");
			Include(Result, "Characters");
			Include(Result, "COBOL");
			Include(Result, "Command_Line");
			Include(Result, "Complex_Arrays");
			Include(Result, "Complex_Elementary_Functions");
			Include(Result, "Complex_IO");
			Include(Result, "Complex_Text_IO");
			Include(Result, "Complex_Types");
			Include(Result, "Constants");
			Include(Result, "Containers");
			Include(Result, "Conversions");
			Include(Result, "Decimal");
			Include(Result, "Direct_IO");
			Include(Result, "Directories");
			Include(Result, "Discrete_Random");
			Include(Result, "Dispatching");
			Include(Result, "Doubly_Linked_Lists");
			Include(Result, "Dynamic_Priorities");
			Include(Result, "EDF");
			Include(Result, "Editing");
			Include(Result, "Elementary_Functions");
			Include(Result, "Environment_Variables");
			Include(Result, "Exceptions");
			Include(Result, "Execution_Time");
			Include(Result, "Finalization");
			Include(Result, "Fixed");
			Include(Result, "Float_Random");
			Include(Result, "Float_Text_IO");
			Include(Result, "Float_Wide_Text_IO");
			Include(Result, "Float_Wide_Wide_Text_IO");
			Include(Result, "Formatting");
			Include(Result, "Fortran");
			Include(Result, "Generic_Array_Sort");
			Include(Result, "Generic_Complex_Arrays");
			Include(Result, "Generic_Complex_Elementary_Functions");
			Include(Result, "Generic_Complex_Types");
			Include(Result, "Generic_Constrained_Array_Sort");
			Include(Result, "Generic_Dispatching_Constructor");
			Include(Result, "Generic_Elementary_Functions");
			Include(Result, "Generic_Real_Arrays");
			Include(Result, "Group_Budgets");
			Include(Result, "Handling");
			Include(Result, "Hash");
			Include(Result, "Hashed_Maps");
			Include(Result, "Hashed_Sets");
			Include(Result, "Indefinite_Doubly_Linked_Lists");
			Include(Result, "Indefinite_Hashed_Maps");
			Include(Result, "Indefinite_Hashed_Sets");
			Include(Result, "Indefinite_Ordered_Maps");
			Include(Result, "Indefinite_Ordered_Sets");
			Include(Result, "Indefinite_Vectors");
			Include(Result, "Information");
			Include(Result, "Integer_Text_IO");
			Include(Result, "Integer_Wide_Text_IO");
			Include(Result, "Integer_Wide_Wide_Text_IO");
			Include(Result, "Interfaces");
			Include(Result, "Interrupts");
			Include(Result, "IO_Exceptions");
			Include(Result, "Latin_1");
			Include(Result, "Machine_Code");
			Include(Result, "Maps");
			Include(Result, "Names");
			Include(Result, "Numerics");
			Include(Result, "Ordered_Maps");
			Include(Result, "Ordered_Sets");
			Include(Result, "Pointers");
			Include(Result, "Real_Arrays");
			Include(Result, "Real_Time");
			Include(Result, "Round_Robin");
			Include(Result, "RPC");
			Include(Result, "Sequential_IO");
			Include(Result, "Standard");
			Include(Result, "Standard");
			Include(Result, "Storage_Elements");
			Include(Result, "Storage_IO");
			Include(Result, "Storage_Pools");
			Include(Result, "Stream_IO");
			Include(Result, "Streams");
			Include(Result, "Strings");
			Include(Result, "Synchronous_Task_Control");
			Include(Result, "System");
			Include(Result, "Tags");
			Include(Result, "Task_Attributes");
			Include(Result, "Task_Identification");
			Include(Result, "Task_Termination");
			Include(Result, "Text_IO");
			Include(Result, "Text_Streams");
			Include(Result, "Time_Zones");
			Include(Result, "Timers");
			Include(Result, "Timing_Events");
			Include(Result, "Unbounded");
			Include(Result, "Unbounded_IO");
			Include(Result, "Unchecked_Conversion");
			Include(Result, "Unchecked_Deallocation");
			Include(Result, "Vectors");
			Include(Result, "Wide_Bounded");
			Include(Result, "Wide_Bounded_IO");
			Include(Result, "Wide_Characters");
			Include(Result, "Wide_Constants");
			Include(Result, "Wide_Fixed");
			Include(Result, "Wide_Hash");
			Include(Result, "Wide_Maps");
			Include(Result, "Wide_Text_IO");
			Include(Result, "Wide_Unbounded");
			Include(Result, "Wide_Unbounded_IO");
			Include(Result, "Wide_Wide_Bounded");
			Include(Result, "Wide_Wide_Bounded_IO");
			Include(Result, "Wide_Wide_Characters");
			Include(Result, "Wide_Wide_Constants");
			Include(Result, "Wide_Wide_Fixed");
			Include(Result, "Wide_Wide_Hash");
			Include(Result, "Wide_Wide_Maps");
			Include(Result, "Wide_Wide_Text_IO");
			Include(Result, "Wide_Wide_Unbounded");
			Include(Result, "Wide_Wide_Unbounded_IO");
		end return;
	end Default_Symbols;
	type string_a is access string;
	type X_Record is record
		Id : string_a;
		Is_Package : Boolean;
		Decl : string_a;
		Decl_In_Spec : Boolean;
		Ref : Boolean;
	end record;
	package X_Lists is new Ada.Containers.Doubly_Linked_Lists(X_Record);
	use X_Lists;
	Symbols : String_Sets.Set;
	Files : String_Sets.Set;
	X : X_Record := (null, false, null, false, false);
	Xs : X_Lists.List;
begin
	if Argument_Count >= 1 then
		declare
			Source_File_Name : constant String := full_name(Ada.Command_Line.Argument(1));
			Project_File_Name : access String;
			Self : constant String := Base_Name(Source_File_Name);
			F : File_Type;
		begin
			if Argument_Count >= 2 then
				Project_File_Name := new String'(full_name(Argument(2)));
				Set_Directory (Containing_Directory(Project_File_Name.all));
			else
				Set_Directory (Containing_Directory(Source_File_Name));
			end if;
			create(f, in_file, form => "shared=yes,wcem=8");
			declare
				gnatmake : aliased process;
				gnatxref : aliased process;
			begin
				if Project_File_Name = null then
					declare
						dir : access String := new String'(Containing_Directory(Source_File_Name));
						obj_dir : access String;
					begin
						loop
							obj_dir := new string'(compose(dir.all, "i686-pc-mingw32"));
							exit when exists(obj_dir.all) and then exists(compose(obj_dir.all, base_name(source_file_name), "ali"));
							obj_dir := new string'(compose(dir.all, "obj"));
							exit when exists(obj_dir.all);
							declare
								parent_dir : constant string_a := new string'(Containing_Directory(dir.all));
							begin
								if (parent_dir.all = dir.all) or else (parent_dir.all = "") then
									obj_dir := new String'(".");
									exit;
								end if;
								dir := parent_dir;
							end;
						end loop;
						create(gnatxref, "gnatxref -a -aO""" & obj_dir.all & """ """ & simple_name(Source_File_Name) & """",
							standard_output => remote_stream(f));
						wait(gnatxref);
					end;
				else
					create(gnatmake, "gnatmake -q -u -gnatQ -gnatc -P """ & simple_name(project_File_Name.all) & """ """ & simple_name(Source_File_Name) & """");
					wait(gnatmake);
					create(gnatxref, "gnat xref -a -P""" & simple_name(project_File_Name.all) & """ """ & simple_name(Source_File_Name) & """",
						standard_output => remote_stream(f));
					wait(gnatxref);
				end if;
				reset(f);
				while not End_Of_File(F) loop
					declare
						S : constant String := Get_Line(F);
					begin
						if S(1) /= ' ' then
							if X.Id /= null and then X.Decl /= null then
								Append(Xs, X);
							end if;
							for P in S'Range loop
								if S(P) = ' ' then
									X.Id := new String'(S(1 .. P - 1));
									goto Exit_Id;
								end if;
							end loop;
							raise Program_Error;
							<<Exit_Id>>
							X.Is_Package := S(S'Last - 6 .. S'Last) = "package"
								or else S(S'Last - 14 .. S'Last) = "generic package";
							X.Ref := False;
						elsif S(10) /= ' ' and then S(10) not in '0' .. '9' then
							for P in 10 .. S'Last loop
								if S(P) = '.' then
									if S(3) = 'D' then
										X.Decl := new String'(S(10 .. P - 1));
										X.Decl_In_Spec := S(P + 1 .. P + 3) = "ads";
									end if;
									if Equal_Case_Insensitive(S(10 .. P - 1), Self) then
										X.Ref := True;
									end if;
									goto Exit_File;
								end if;
							end loop;
							raise Program_Error;
							<<Exit_File>> null;
						end if;
					end;
				end loop;
				declare
					procedure Process(Position : X_Lists.Cursor) is
						X : X_Record renames Element(Position);
					begin
						if X.Ref and then X.Is_Package then
							Include(Files, X.Decl.all);
						end if;
					end Process;
				begin
					Iterate(Xs, Process'Access);
				end;
				declare
					procedure Process(Position : X_Lists.Cursor) is
						X : X_Record renames Element(Position);
					begin
						if X.Ref or else (X.Decl_In_Spec and then Contains(Files, X.Decl.all)) then
							Include(Symbols, X.Id.all);
						end if;
					end Process;
				begin
					Iterate(Xs, Process'Access);
				end;
			end;
			Close(F);
		end;
	end if;
	if Is_Empty(Symbols) then
		Union(Symbols, Default_Symbols);
	end if;
	declare
		procedure Process(Position : String_Sets.Cursor) is
		begin
			Put(Element(Position)); New_Line;
		end Process;
	begin
		Iterate(Symbols, Process'Access);
	end;
end list_ali;
