with ada.Command_Line; use ada.Command_Line;
with ada.text_io; use ada.Text_IO;
with ada.Directories; use ada.Directories;
with ada.Unchecked_Deallocation;
with Ase.Memory_Mapped_IO; use Ase.Memory_Mapped_IO;
procedure list_tags is
	type string_a is access string;
	procedure free is new ada.Unchecked_Deallocation(string, string_a);
	function get_target return string is
	begin
		if argument_count >= 1 then
			return full_name(argument(1));
		else
			return current_directory;
		end if;
	end get_target;
	dir : string_a := new string'(get_target);
	tags : string_a;
begin
	loop
		tags := new string'(compose(dir.all, "tags"));
		exit when exists(tags.all);
		declare
			parent_dir : constant string_a := new string'(Containing_Directory(dir.all));
		begin
			if (parent_dir.all = dir.all) or else (parent_dir.all = "") then
				put_line("printf"); -- nagusami
				return;
			end if;
			free(dir);
			dir := parent_dir;
		end;
	end loop;
	declare
		f : mapping;
	begin
		map(f, In_File, tags.all, form => "shared=yes");
		declare
			package s is new String_IO(f);
			pre_f : positive := 1;
			pre_l : natural := 0;
			p : positive := 1;
		begin
			while p <= s.item'last loop
				declare
					l : positive := p;
				begin
					while s.item(l) /= ascii.lf loop
						l := l + 1;
					end loop;
					if s.item(p) /= '!' then
						for i in p .. l loop
							if s.item(i) = character'val(9) then
								if s.item(pre_f .. pre_l) /= s.item(p .. i - 1) then
									put_line(s.item(p .. i - 1));
									pre_f := p;
									pre_l := i - 1;
								end if;
								exit;
							end if;
						end loop;
					end if;
					p := l + 1;
				end;
			end loop;
		end;
		unmap(f);
	end;
end list_tags;
